package com.spring.series.jdbc;

import java.util.List;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.spring.series.jdbc.dao.PlayerDAO;
import com.spring.series.jdbc.model.Player;

public class TestPlayerInfo {

	public static void main(String[] args) {
		testSpringNamedParameterJdbcTemplate();
	}

	/**
	 * Test method : invokes all public DAO methods using Spring Dependency Injection after loading the context xml file
	 */
	private static void testSpringNamedParameterJdbcTemplate(){

		// loads the context xml and uses getBean() to retrieve the bean
		ApplicationContext applicationContext = new ClassPathXmlApplicationContext("com/spring/series/jdbc/SpringContext.xml");
		PlayerDAO playerDAO = (PlayerDAO) applicationContext.getBean("playerDAO");

		System.out.println("\nSpring Simple JDBC Template Demostration using spring datasource");

		// invokes createOrSaveNewPLayer() method
		System.out.println("\nA. Invkoing createOrSaveNewPLayer() method to create/save new player information");
		Player newPlayer = new Player("Tamim Iqbal", 24, 19);
		String strCreateOrSave = playerDAO.createOrSaveNewPLayer(newPlayer);
		System.out.println("Return message : " + strCreateOrSave);

		// invokes getPlayer() method
		System.out.println("\nB. Invkoing getPlayer() method to retrieve player based on the player_id supplied in the formal argument");
		Player player5 = playerDAO.getPlayer(1);
		System.out.println("ID\tName\t\t\tAge\tMatches");
		System.out.println("==\t================\t===\t=======");
		System.out.println(player5.getPlayerId() + "\t" + player5.getName() + "\t" + player5.getAge() + "\t" + player5.getMatches());

		// invokes updatePlayerInfo() method
		System.out.println("\nC. Invkoing updatePlayerInfo() method to update Player information");
		Player updatePlayer = new Player(2, "Shane Warne", 45, 149);
		String strUpdate = playerDAO.updatePlayerInfo(updatePlayer);
		System.out.println("Return message : " + strUpdate);

		// invokes deletePlayerInfo() method
		System.out.println("\nD. Invkoing deletePlayerInfo() method to delete player inforamtion from the database");
		String strDelete = playerDAO.deletePlayerInfo("7");
		System.out.println("Return message : " + strDelete);

		// invokes getAllPlayer() method
		System.out.println("\nE. Invkoing getAllPlayer() method to retrieve all players from the database");
		System.out.println("ID\tName\t\t\tAge\tMatches");
		System.out.println("==\t================\t===\t=======");
		List<Player> lstPlayer = playerDAO.getAllPlayer();
		for(Player player : lstPlayer){
			System.out.println(player.getPlayerId() + "\t" + player.getName() + "\t" + player.getAge() + "\t" + player.getMatches());
		}
	}
}